# -*- Mode: Java; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 4 -*-
# ***** BEGIN LICENSE BLOCK *****
# Version: MPL 1.1/GPL 2.0/LGPL 2.1
#
# The contents of this file are subject to the Mozilla Public License Version
# 1.1 (the "License"); you may not use this file except in compliance with
# the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS" basis,
# WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
# for the specific language governing rights and limitations under the
# License.
#
# The Original Code is Mozilla Communicator client code, released
# March 31, 1998.
#
# The Initial Developer of the Original Code is
# Netscape Communications Corporation.
# Portions created by the Initial Developer are Copyright (C) 1998-1999
# the Initial Developer. All Rights Reserved.
#
# Contributor(s):
#   Jan Varga <varga@nixcorp.com>
#   HÂkan Waara (hwaara@chello.se)
#   Postbox, Inc. <contact@postbox-inc.com>
#
# Alternatively, the contents of this file may be used under the terms of
# either the GNU General Public License Version 2 or later (the "GPL"), or
# the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
# in which case the provisions of the GPL or the LGPL are applicable instead
# of those above. If you wish to allow use of your version of this file only
# under the terms of either the GPL or the LGPL, and not to allow others to
# use your version of this file under the terms of the MPL, indicate your
# decision by deleting the provisions above and replace them with the notice
# and other provisions required by the GPL or the LGPL. If you do not delete
# the provisions above, a recipient may use your version of this file under
# the terms of any one of the MPL, the GPL or the LGPL.
#
# ***** END LICENSE BLOCK *****

//This file stores variables common to mail windows
var messengerContractID        = "@mozilla.org/messenger;1";
var statusFeedbackContractID   = "@mozilla.org/messenger/statusfeedback;1";
var mailSessionContractID      = "@mozilla.org/messenger/services/session;1";
var msgWindowContractID      = "@mozilla.org/messenger/msgwindow;1";

var messenger;
var pref;
var statusFeedback;
var msgWindow;

var msgComposeService;
var accountManager;
var RDF;
var msgComposeType;
var msgComposeFormat;

var mailSession;

var gMessengerBundle;
var gBrandBundle;

var gContextMenu;

//End progress and Status variables

function OnMailWindowUnload()
{
  MailOfflineMgr.uninit();
  ClearPendingReadTimer();
  gGestureSupport.init(false);

  var searchSession = GetSearchSession();
  if (searchSession)
  {
    gQuickSearchController.close(); // unregister various search listeners
    if (gPreQuickSearchView)     //close the cached pre quick search view
      gPreQuickSearchView.close();
  }

  var dbview = GetDBView();
  if (dbview) {
    dbview.close();
  }

  var mailSession = Components.classes[mailSessionContractID].getService();
  if(mailSession)
  {
    mailSession = mailSession.QueryInterface(Components.interfaces.nsIMsgMailSession);
    if(mailSession)
      mailSession.RemoveFolderListener(folderListener);
  }

  mailSession.RemoveMsgWindow(msgWindow);
  messenger.setWindow(null, null);
  msgWindow.closeWindow();

  window.MsgStatusFeedback.unload();
  Components.classes["@mozilla.org/activity-manager;1"]
            .getService(Components.interfaces.nsIActivityManager)
            .removeListener(window.MsgStatusFeedback);

  var addrbookSession = Components.classes["@mozilla.org/addressbook/services/session;1"].
                          getService(Components.interfaces.nsIAddrBookSession);
  addrbookSession.removeAddressBookListener(pbAddressBookChangeObserver);
}

function CreateMessenger()
{
  messenger = Components.classes[messengerContractID].createInstance(Components.interfaces.nsIMessenger);
}

function CreateMailWindowGlobals()
{
  // get the messenger instance
  CreateMessenger();

  pref = Components.classes["@mozilla.org/preferences-service;1"]
          .getService(Components.interfaces.nsIPrefBranch2);

  //Create windows status feedback
  // set the JS implementation of status feedback before creating the c++ one..
  window.MsgStatusFeedback = new nsMsgStatusFeedback();
  // double register the status feedback object as the xul browser window implementation
  window.QueryInterface(Components.interfaces.nsIInterfaceRequestor)
        .getInterface(Components.interfaces.nsIWebNavigation)
        .QueryInterface(Components.interfaces.nsIDocShellTreeItem).treeOwner
        .QueryInterface(Components.interfaces.nsIInterfaceRequestor)
        .getInterface(Components.interfaces.nsIXULWindow)
        .XULBrowserWindow = window.MsgStatusFeedback;

  statusFeedback = Components.classes[statusFeedbackContractID].createInstance();
  statusFeedback = statusFeedback.QueryInterface(Components.interfaces.nsIMsgStatusFeedback);
  statusFeedback.setWrappedStatusFeedback(window.MsgStatusFeedback);

  Components.classes["@mozilla.org/activity-manager;1"]
            .getService(Components.interfaces.nsIActivityManager)
            .addListener(window.MsgStatusFeedback);

  //Create message window object
  msgWindow = Components.classes[msgWindowContractID].createInstance();
  msgWindow = msgWindow.QueryInterface(Components.interfaces.nsIMsgWindow);

  msgComposeService = Components.classes['@mozilla.org/messengercompose;1'].getService();
  msgComposeService = msgComposeService.QueryInterface(Components.interfaces.nsIMsgComposeService);

  mailSession = Components.classes["@mozilla.org/messenger/services/session;1"].getService(Components.interfaces.nsIMsgMailSession);

  accountManager = Components.classes["@mozilla.org/messenger/account-manager;1"].getService(Components.interfaces.nsIMsgAccountManager);

  RDF = Components.classes['@mozilla.org/rdf/rdf-service;1'].getService();
  RDF = RDF.QueryInterface(Components.interfaces.nsIRDFService);

  msgComposeType = Components.interfaces.nsIMsgCompType;
  msgComposeFormat = Components.interfaces.nsIMsgCompFormat;

  gMessengerBundle = document.getElementById("bundle_messenger");
  gBrandBundle = document.getElementById("bundle_brand");

  msgWindow.notificationCallbacks = new BadCertHandler();
}

function InitMsgWindow()
{
  // setup simple gestures support
  gGestureSupport.init(true);
  msgWindow.windowCommands = new nsMsgWindowCommands();
  // set the domWindow before setting the status feedback and header sink objects
  msgWindow.domWindow = window;
  msgWindow.statusFeedback = statusFeedback;
  msgWindow.msgHeaderSink = messageHeaderSink;
  mailSession.AddMsgWindow(msgWindow);
  var msgPaneDocShell = document.getElementById("messagepane").docShell;
  msgPaneDocShell.allowAuth = false;
  msgPaneDocShell.allowDNSPrefetch = false;
  msgWindow.rootDocShell.allowAuth = true;
  // Ensure we don't load xul error pages into the main window
  msgWindow.rootDocShell.useErrorPages = false;
}

/**
 * mscott - to do, let's hand roll these menus instead of using the datasource. then we can remove our last dependency
 * on nsMsgFolderDataSource.cpp!
 */
function SetupMoveCopyMenus(aMenu)
{
  var accountManagerDataSource = Components.classes['@mozilla.org/rdf/datasource;1?name=msgaccountmanager'].
                                   getService(Components.interfaces.nsIMsgRDFDataSource);
  accountManagerDataSource.window = msgWindow; // is this really necessary?
  var folderDataSource =  Components.classes['@mozilla.org/rdf/datasource;1?name=mailnewsfolders'].
                            getService(Components.interfaces.nsIMsgRDFDataSource);
  folderDataSource.window = msgWindow; // is this really necessary?
  // if we've already added our datasources, don't bother doing it again...
  var enumerator = aMenu.database.GetDataSources();
  var found = false;
  while (enumerator.hasMoreElements() && !found)
  {
    // one of our datasources matching is as good as both...
    var datasource = enumerator.getNext();
    if (datasource instanceof Components.interfaces.nsIMsgRDFDataSource &&
        datasource == accountManagerDataSource)
      found = true;
  }

  if (!found)
  {
    aMenu.database.AddDataSource(accountManagerDataSource.QueryInterface(Components.interfaces.nsIRDFDataSource));
    aMenu.database.AddDataSource(folderDataSource.QueryInterface(Components.interfaces.nsIRDFDataSource));
    aMenu.setAttribute('ref', 'msgaccounts:/');
   }
}

// We're going to implement our status feedback for the mail window in JS now.
// the following contains the implementation of our status feedback object

function nsMsgStatusFeedback()
{
  this._statusText = document.getElementById("statusbar-display");
  this._progressBar = document.getElementById("statusbar-icon");
  this._activeProcesses = new Array();
}

nsMsgStatusFeedback.prototype =
{
  // Document elements.
  _statusText: null,
  _progressBar: null,

  // Member variables.
  _startTimeoutID: null,
  _stopTimeoutID: null,
  // How many start meteors have been requested.
  _startRequests: 0,
  _meteorsSpinning: false,
  _defaultStatusText: null,
  _statusFeedbackProgress: -1,
  _activeProcesses: null,
  _pbStatusTextTimerId: null,

  // unload - call to remove links to listeners etc.
  unload: function () {
    // Remove listeners for any active processes we have hooked ourselves into.
    this._activeProcesses.forEach(function (element) {
        element.removeListener(this);
      }, this);
  },

  // nsIXULBrowserWindow implementation.
  setJSStatus: function(status) {
    if (status.length > 0)
      this.showStatusString(status);
  },

  setJSDefaultStatus: function(status) {
    if (status.length > 0) {
      this._defaultStatusText = status;
      this._statusText.label = status;
      if (this._pbStatusTextTimerId)
      {
        clearTimeout(this._pbStatusTextTimerId);
        this._pbStatusTextTimerId = null;
      }
      // IMAP uses setJSDefaultStatus to set random server error strings like unable to connect to the server that never go away.
      // so for any text coming through setJSDefaultStatus, clear it after a second or so.
      this.pbStatusTextTimerId = setTimeout("window.MsgStatusFeedback._defaultStatusText = ''; window.MsgStatusFeedback._statusText.label = '';", 1000); // safe to clear status text
    }
  },

  setOverLink: function(link, context) {
    if (this._pbStatusTextTimerId)
    {
      clearTimeout(this._pbStatusTextTimerId);
      this._pbStatusTextTimerId = null;
    }
    this._statusText.label = link;
  },

  // Called before links are navigated to to allow us to retarget them if needed.
  onBeforeLinkTraversal: function(originalTarget, linkURI, linkNode, isAppTab) {
    return originalTarget;
  },
  
  QueryInterface: function(iid) {
    if (iid.equals(Components.interfaces.nsIMsgStatusFeedback) ||
        iid.equals(Components.interfaces.nsIXULBrowserWindow) ||
        iid.equals(Components.interfaces.nsIActivityMgrListener) ||
        iid.equals(Components.interfaces.nsIActivityListener) ||
        iid.equals(Components.interfaces.nsISupportsWeakReference) ||
        iid.equals(Components.interfaces.nsISupports))
      return this;
    throw Components.results.NS_NOINTERFACE;
  },

  // nsIMsgStatusFeedback implementation.
  showStatusString: function(statusText) {
    if (statusText && this._pbStatusTextTimerId)
    {
      clearTimeout(this._pbStatusTextTimerId);
      this._pbStatusTextTimerId = null;
    }
    if (!statusText)
      statusText = this._defaultStatusText;
    else
      this._defaultStatusText = "";
    if (!statusText && "MsgStatusFeedback" in window)
      this.pbStatusTextTimerId = setTimeout("window.MsgStatusFeedback._statusText.label = '';", 1000); // safe to clear status text
    else
      this._statusText.label = statusText;
  },

  _startMeteors: function() {
    this._meteorsSpinning = true;
    this._startTimeoutID = null;

    // Turn progress meter on.
    this.updateProgress();
  },

  startMeteors: function() {
    this._startRequests++;
    // If we don't already have a start meteor timeout pending
    // and the meteors aren't spinning, then kick off a start.
    if (!this._startTimeoutID && !this._meteorsSpinning &&
        "MsgStatusFeedback" in window)
      this._startTimeoutID =
        setTimeout('window.MsgStatusFeedback._startMeteors();', 250);

    // Since we are going to start up the throbber no sense in processing
    // a stop timeout...
    if (this._stopTimeoutID) {
      clearTimeout(this._stopTimeoutID);
      this._stopTimeoutID = null;
    }
  },

  _stopMeteors: function() {
    this.showStatusString(defaultStatus);

    this._meteorsSpinning = false;
    this._stopTimeoutID = null;

    // Turn progress meter off.
    this._statusFeedbackProgress = -1;
    this.updateProgress();
  },

  stopMeteors: function() {
    if (this._startRequests > 0)
      this._startRequests--;

    // If we are going to be starting the meteors, cancel the start.
    if (this._startRequests == 0 && this._startTimeoutID) {
      clearTimeout(this._startTimeoutID);
      this._startTimeoutID = null;
    }

    // If we have no more pending starts and we don't have a stop timeout
    // already in progress AND the meteors are currently running then fire a
    // stop timeout to shut them down.
    if (this._startRequests == 0 && !this._stopTimeoutID &&
        this._meteorsSpinning && "MsgStatusFeedback" in window) {
      // never leave pie visible
      if (this._statusText.label && "MsgStatusFeedback" in window)
        this._stopTimeoutID =
          setTimeout('window.MsgStatusFeedback._stopMeteors();', 1000); // if status text, keep the timer's the same
      else
        this._stopMeteors();
    }
  },

  showProgress: function(percentage) {
    this._statusFeedbackProgress = percentage;
    this.updateProgress();
  },

  updateProgress: function() {
    // Postbox specific optimization - avoid showing meteors if we don't have matching status text
    if (this._meteorsSpinning && this._statusText.label) {

      // In this function, we expect that the maximum for each progress is 100,
      // i.e. we are dealing with percentages. Hence we can combine several
      // processes running at the same time.
      let currentProgress = 0;
      let progressCount = 0;

      // For each activity that is in progress, get its status.

      this._activeProcesses.forEach(function (element) {
          if (element.state ==
              Components.interfaces.nsIActivityProcess.STATE_INPROGRESS &&
              element.percentComplete != -1) {
            currentProgress += element.percentComplete;
            ++progressCount;
          }
        });

      // Add the generic progress that's fed to the status feedback object if
      // we've got one.
      if (this._statusFeedbackProgress != -1) {
        currentProgress += this._statusFeedbackProgress;
        ++progressCount;
      }

      let percentage = 0;
      if (progressCount) {
        percentage = currentProgress / progressCount;
      }

      if (!percentage || percentage == -1)
        this._progressBar.setAttribute("mode", "undetermined");
      else {
        this._progressBar.setAttribute("mode", "normal"); // Thunderbird calls this determined
        this._progressBar.value = percentage;
        this._progressBar.label = Math.round(percentage) + "%";
      }
    }
    else {
      this._meteorsSpinning = false;
      this._stopTimeoutID = null;
      this._startRequests = 0; 

      // Stop the bar spinning as we're not doing anything now.
      this._progressBar.removeAttribute("mode");
      this._progressBar.value = 0;
      this._progressBar.label = "";
    }
  },

  // nsIActivityMgrListener
  onAddedActivity: function(aID, aActivity) {
    // ignore Gloda activity for status bar purposes
//    if (aActivity.initiator == Gloda)
//      return;
    if (aActivity instanceof Components.interfaces.nsIActivityEvent) {
      this.showStatusString(aActivity.displayText);
    }
    else if (aActivity instanceof Components.interfaces.nsIActivityProcess) {
      this._activeProcesses.push(aActivity);
      aActivity.addListener(this);
      this.startMeteors();
    }
  },

  onRemovedActivity: function(aID) {
    this._activeProcesses =
      this._activeProcesses.filter(function (element) {
        if (element.id == aID) {
          element.removeListener(this);
          this.stopMeteors();
          return false;
        }
        return true;
      }, this);
  },

  // nsIActivityListener
  onStateChanged: function(aActivity, aOldState) {
  },

  onProgressChanged: function(aActivity, aStatusText, aWorkUnitsCompleted,
                              aTotalWorkUnits) {
    let index = this._activeProcesses.indexOf(aActivity);

    // Iterate through the list trying to find the first active process, but
    // only go as far as our process.
    for (var i = 0; i < index; ++i) {
      if (this._activeProcesses[i].status ==
          Components.interfaces.nsIActivityProcess.STATE_INPROGRESS)
        break;
    }

    // If the found activity was the same as our activity, update the status
    // text.
    if (i == index)
      // Use the display text if we haven't got any status text. I'm assuming
      // that the status text will be generally what we want to see on the
      // status bar.
      this.showStatusString(aStatusText ? aStatusText : aActivity.displayText);

    this.updateProgress();
  },

  onHandlerChanged: function(aActivity) {
  }
}

function nsMsgWindowCommands()
{
}

nsMsgWindowCommands.prototype =
{
  QueryInterface : function(iid)
  {
    if (iid.equals(Components.interfaces.nsIMsgWindowCommands) ||
        iid.equals(Components.interfaces.nsISupports))
      return this;
    throw Components.results.NS_NOINTERFACE;
  },

  selectFolder: function(folderUri)
  {
    SelectFolder(folderUri);
  },

  selectMessage: function(messageUri)
  {
    SelectMessage(messageUri);
  },

  clearMsgPane: function()
  {
    if (gDBView)
      setTitleFromFolder(gDBView.msgFolder,null);
    else
      setTitleFromFolder(null,null);
    ClearMessagePane();
  },
  
  get view() {
    var tabmail = document.getElementById('tabmail');
    // if a stand alone msg window or we are on a folder or message tab, return the underlying view.
    if (!tabmail || (tabmail.currentTabOwner && (tabmail.currentTabOwner.type == 'folder' || tabmail.currentTabOwner.type == 'message')))
      return gDBView;
    else
      return null;
  }
}

function StopUrls()
{
  msgWindow.StopUrls();
}


/**
 * @returns the pref name to use for fetching the start page url. Every time the application version changes,
 * return "pb.start_page.override_url". If this is the first time the application has been
 * launched, return "pb.start_page.welcome_url". Otherwise return "pb.start_page.url".
 */
function startPageUrlPref()
{
  var prefForStartPageUrl = "pb.start_page.url";
  var savedVersion = null;
  try {
    savedVersion = pref.getCharPref("pb.start_page_override.mstone");
  } catch (ex) {}

  if (savedVersion != "ignore")
  {
    var app = Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULAppInfo);
    app.QueryInterface(Components.interfaces.nsIXULRuntime);
    
    pref.setCharPref("pb.start_page_override.mstone", app.version);
    // Use the welcome URL the first time we run
    if (!savedVersion)
    {
      prefForStartPageUrl = "pb.start_page.welcome_url";
    }
    else if (app.version != savedVersion)
    {
      prefForStartPageUrl = "pb.start_page.override_url";
    }
  }

  // on first run or after update, add a splat to the promote button
  if (prefForStartPageUrl != "pb.start_page.url")
  {
    var promoteButton = document.getElementById("pbToolbarButton-promote");
    if (promoteButton)
      promoteButton.setAttribute("splat","true");
    
    // on first run or after update, register the app
    try 
    {
      let systemServicesService = Components.classes["@postbox-inc.com/systemservices;1"].getService(Components.interfaces.pbISystemServices);
      if (systemServicesService)
        systemServicesService.register();
    } 
    catch (ex) 
    {
    }
  }  
  return prefForStartPageUrl;
}

function loadStartPage()
{
  try
  {
    // used to style the message pane box differently when displaying a message vs. the start page
    document.getElementById('messagepanebox').removeAttribute('message');
    gMessageNotificationBar.clearMsgNotifications();
    // unlock the message pane browser instance before we load the start page. This allows the start page
    // to run javascript and act as a single site browser
    UnRestrictMessagePane();
    // only load the start page if we are online
    var startpage = getFormattedURL(startPageUrlPref());
    // load about:blank as the start page if we are offline or we don't have a start page url...
    var msgPaneBrowser = document.getElementById("messagepane");
    msgPaneBrowser.webNavigation.loadURI(startpage && MailOfflineMgr.isOnline() ? startpage : "about:blank", 0, null, null, null);
    ClearMessageSelection();
  }
  catch (ex)
  {
    dump("Error loading start page.\n");
    return;
  }
}

// When the ThreadPane is hidden via the displayDeck, we should collapse the
// elements that are only meaningful to the thread pane. When AccountCentral is
// shown via the displayDeck, we need to switch the displayDeck to show the
// accountCentralBox, and load the iframe in the AccountCentral box with
// corresponding page.
function ShowAccountCentral()
{
  try
  {
    SelectPanelInDisplayDeck("accountCentralBox");
    var acctCentralPage = pref.getCharPref("mailnews.account_central_page.url");;
    window.frames["accountCentralPane"].location.href = acctCentralPage;
  }
  catch (ex)
  {
    dump("Error loading AccountCentral page -> " + ex + "\n");
  }
}

function ShowRichSearchResults()
{
  SelectPanelInDisplayDeck("searchResultsBox");
  // update toolbar commands when popping into rich search results view
  UpdateMailToolbar('showing rich search results');
}

/**
 * @returns true if we are currently showing rich search results
 */
function ShowingRichSearchResults()
{
  // the display deck is visible and that the search results box is the selected panel
  var displayDeck = document.getElementById("displayDeck");
  return !displayDeck.collapsed && displayDeck.selectedPanel == document.getElementById('searchResultsBox');
}

/**
 * @return true if the thread pane is the selected item in the display deck 
 */
function IsThreadPaneVisible()
{
  var displayDeck = document.getElementById("displayDeck");
  return (displayDeck && !displayDeck.collapsed && displayDeck.selectedPanel == document.getElementById("threadPaneBox"));
}

function SelectPanelInDisplayDeck(aSelectedPanelId)
{
  try 
  {
   // when showing the thread pane, make sure we collapse the searchResultsBox,
   // which includes the full image and the richlistbox,
   // both of which can affect the message pane splitter
   document.getElementById("searchResultsBox").collapsed = (aSelectedPanelId != "searchResultsBox");
  }
  catch (ex) {}
  document.getElementById("displayDeck").selectedPanel = document.getElementById(aSelectedPanelId);
}

function ShowThreadPane()
{
  SelectPanelInDisplayDeck("threadPaneBox");
}

function ShowingThreadPane()
{
  var threadPaneSplitter = document.getElementById("threadpane-splitter");
  threadPaneSplitter.collapsed = false;
  GetMessagePane().collapsed = (threadPaneSplitter.getAttribute("state") == "collapsed");
  // XXX We need to force the tree to refresh its new height
  // so that it will correctly scroll to the newest message
  GetThreadTree().boxObject.height;
  document.getElementById("key_toggleMessagePane").removeAttribute("disabled");
}

function HideThreadPane()
{
  GetUnreadCountElement().hidden = true;
  GetTotalCountElement().hidden = true;
  GetMessagePane().collapsed = true;
  document.getElementById("threadpane-splitter").collapsed = true;
  document.getElementById("key_toggleMessagePane").setAttribute("disabled", "true");
}

// the find toolbar needs a method called getBrowser
function getBrowser()
{
  return getMessageBrowser();
}

var gCurrentDisplayDeckId = "";
function ObserveDisplayDeckChange(event)
{
  var selectedPanel = document.getElementById("displayDeck").selectedPanel;
  var nowSelected = selectedPanel ? selectedPanel.id : null;
  // onselect fires for every mouse click inside the deck, so ObserveDisplayDeckChange is getting called every time we click
  // on a message in the thread pane. Only show / Hide elements if the selected deck is actually changing.

  // this hiding / showing of the thread pane is causing a lot of confusion in the tab owner code 'cause some of it is happening here
  // when the tab owner really knows what to do. But changing this breaks lightning...I'm not sure what to do.
  if (nowSelected != gCurrentDisplayDeckId)
  {
    if (nowSelected == "threadPaneBox")
      ShowingThreadPane();
    else
    {
      HideThreadPane();
      if (!IsFolderPaneCollapsed())
        GetFolderTree().focus();
    }
    gCurrentDisplayDeckId = nowSelected;
  }
}

// Given the server, open the twisty and the set the selection
// on inbox of that server.
// prompt if offline.
function OpenInboxForServer(server)
{
  try {
    ShowThreadPane();
    var inboxFolder = GetInboxFolder(server);
    SelectFolder(inboxFolder.URI);

    if (MailOfflineMgr.isOnline() || MailOfflineMgr.getNewMail())  {
      if (server.type != "imap")
        GetMessagesForInboxOnServer(server);
    }
  }
  catch (ex) {
      dump("Error opening inbox for server -> " + ex + "\n");
      return;
  }
}

function GetSearchSession()
{
  if (("gSearchSession" in top) && gSearchSession)
    return gSearchSession;
  else
    return null;
}

/**
 * This class implements nsIBadCertListener2.  Its job is to prevent "bad cert"
 * security dialogs from being shown to the user.  Currently it puts up the
 * cert override dialog, though we'd like to give the user more detailed
 * information in the future.
 */
function BadCertHandler() {
}

BadCertHandler.prototype = {
  // Suppress any certificate errors
  notifyCertProblem: function(socketInfo, status, targetSite) {
    if (!status)
      return true;

    setTimeout(InformUserOfCertError, 0, socketInfo, targetSite);
    return true;
  },

  // nsIInterfaceRequestor
  getInterface: function(iid) {
    return this.QueryInterface(iid);
  },

  // nsISupports
  QueryInterface: function(iid) {
    if (!iid.equals(Components.interfaces.nsIBadCertListener2) &&
      !iid.equals(Components.interfaces.nsIInterfaceRequestor) &&
      !iid.equals(Components.interfaces.nsISupports))
      throw Components.results.NS_ERROR_NO_INTERFACE;
    return this;
  }
};

function InformUserOfCertError(socketInfo, targetSite)
{
  var params = { exceptionAdded : false };
  params.prefetchCert = true;
  params.location = targetSite;
  window.openDialog('chrome://pippki/content/exceptionDialog.xul',
                  '','chrome,centerscreen,modal', params);
}

/**
 * Content area tooltip.
 * XXX - this must move into XBL binding/equiv! Do not want to pollute
 *       browser.js with functionality that can be encapsulated into
 *       browser widget. TEMPORARY!
 *
 * NOTE: Any changes to this routine need to be mirrored in DefaultTooltipTextProvider::GetNodeText()
 *       (located in mozilla/embedding/browser/webBrowser/nsDocShellTreeOwner.cpp)
 *       which performs the same function, but for embedded clients that
 *       don't use a XUL/JS layer. It is important that the logic of
 *       these two routines be kept more or less in sync.
 *       (pinkerton)
 **/
function FillInHTMLTooltip(tipElement)
{
  var retVal = false;
  // Don't show the tooltip if the tooltip node is a XUL element or a document.
  if (tipElement.namespaceURI == "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul" ||
      !tipElement.ownerDocument)
    return retVal;
  
  const XLinkNS = "http://www.w3.org/1999/xlink";
  
  
  var titleText = null;
  var XLinkTitleText = null;
  var SVGTitleText = null;
  var lookingForSVGTitle = true;
  var direction = tipElement.ownerDocument.dir;
  
  // If the element is invalid per HTML5 Forms specifications and has no title,
  // show the constraint validation error message.
  if ((tipElement instanceof HTMLInputElement ||
       tipElement instanceof HTMLTextAreaElement ||
       tipElement instanceof HTMLSelectElement ||
       tipElement instanceof HTMLButtonElement) &&
      !tipElement.hasAttribute('title') &&
      (!tipElement.form || !tipElement.form.noValidate)) {
    // If the element is barred from constraint validation or valid,
    // the validation message will be the empty string.
    titleText = tipElement.validationMessage;
  }
  
  while (!titleText && !XLinkTitleText && !SVGTitleText && tipElement) {
    if (tipElement.nodeType == Node.ELEMENT_NODE) {
      titleText = tipElement.getAttribute("title");
      if ((tipElement instanceof HTMLAnchorElement && tipElement.href) ||
          (tipElement instanceof HTMLAreaElement && tipElement.href) ||
          (tipElement instanceof HTMLLinkElement && tipElement.href) ||
          (tipElement instanceof SVGAElement && tipElement.hasAttributeNS(XLinkNS, "href"))) {
        XLinkTitleText = tipElement.getAttributeNS(XLinkNS, "title");
      }
      if (lookingForSVGTitle &&
          (!(tipElement instanceof SVGElement) ||
           tipElement.parentNode.nodeType == Node.DOCUMENT_NODE)) {
            lookingForSVGTitle = false;
          }
      if (lookingForSVGTitle) {
        let length = tipElement.childNodes.length;
        for (let i = 0; i < length; i++) {
          let childNode = tipElement.childNodes[i];
          if (childNode instanceof SVGTitleElement) {
            SVGTitleText = childNode.textContent;
            break;
          }
        }
      }
      var defView = tipElement.ownerDocument.defaultView;
      // XXX Work around bug 350679:
      // "Tooltips can be fired in documents with no view".
      if (!defView)
        return retVal;
      direction = defView.getComputedStyle(tipElement, "")
      .getPropertyValue("direction");
    }
    tipElement = tipElement.parentNode;
  }
  
  var tipNode = document.getElementById("aHTMLTooltip");
  tipNode.style.direction = direction;
  
  [titleText, XLinkTitleText, SVGTitleText].forEach(function (t) {
                                                    if (t && /\S/.test(t)) {
                                                    
                                                    // Per HTML 4.01 6.2 (CDATA section), literal CRs and tabs should be
                                                    // replaced with spaces, and LFs should be removed entirely.
                                                    // XXX Bug 322270: We don't preserve the result of entities like &#13;,
                                                    // which should result in a line break in the tooltip, because we can't
                                                    // distinguish that from a literal character in the source by this point.
                                                    t = t.replace(/[\r\t]/g, ' ');
                                                    t = t.replace(/\n/g, '');
                                                    
                                                    tipNode.setAttribute("label", t);
                                                    retVal = true;
                                                    }
                                                    });
  
  return retVal;
}

/**
 * shared between the stand alone message window and the 3-pane window
 */
function GetMessagePaneFrame()
{
  return window.content;
}

var _dirtyClearMsgPaneSuppressionHack = false; // hack to avoid clearing the message pane when opening a message tab to reduce flickr
function ClearMessagePane()
{
  if (_dirtyClearMsgPaneSuppressionHack)
  {
    // should we still call ClearPendingReadTimer?
    return;
  }

  var wintype = document.documentElement.getAttribute('windowtype');
  
  if(wintype != 'mail:3pane' || gHaveLoadedMessage)
  {
    if (wintype == 'mail:3pane')
      gHaveLoadedMessage = false;
    if (GetMessagePaneFrame() &&
        GetMessagePaneFrame().location.href != "about:blank")
        GetMessagePaneFrame().location.href = "about:blank";

    // hide the message header view AND the message pane...
    setTimeout(HideMessageHeaderPane, 5);
    gMessageNotificationBar.clearMsgNotifications();
    ClearPendingReadTimer();
  }
}
        
#include pbMailWindow.js
