function populateIndexerSection() {
  const kDBFile = "msgfti2.sqlite"; // keep in sync with nsMsgFullTextIndexer.js 
  const nsIDirectoryServiceContractID = "@mozilla.org/file/directory_service;1"; 
  const nsIProperties = Components.interfaces.nsIProperties; 
  var directoryService =  Components.classes[nsIDirectoryServiceContractID].getService(nsIProperties); 
  var db = directoryService.get("ProfLD", Components.interfaces.nsIFile); 
  db.append(kDBFile); 

  var fileSizeMessage = db.path + " ";
  if (db.exists()) {
    fileSizeMessage += db.fileSize;
  }
  else {
    fileSizeMessage += "-1";
  }

  let tdName = createElement("td", fileSizeMessage, {"class": "name"});
  let tr = createParentElement("tr", [tdName]);
  appendChildren(document.getElementById("indexer-tbody"), [tr]);

  var callback = {
    logStringMessage : function (message) {
      let tdName = createElement("td", message, {"class": "name"});
      let tr = createParentElement("tr", [tdName]);
      appendChildren(document.getElementById("indexer-tbody"), [tr]);
    },
  };

  Components.classes['@mozilla.org/msg-global-index;1'].getService(Components.interfaces.nsIMsgGlobalIndex).dumpStatsForSupport(callback);
}
