/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */

/**
 * mscottFIXME - insert a license file here XYZ
 * 
 * this code is based on code from chatzilla:
 * mozilla/extensions/irc/xul/content/static.js
 * mozilla/extensions/irc/xul/content/handlers.js
 *  
 */

/* -*- Mode: C++; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is ChatZilla.
 *
 * The Initial Developer of the Original Code is
 * New Dimensions Consulting, Inc.
 * Portions created by the Initial Developer are Copyright (C) 1999
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *   Robert Ginda, rginda@netscape.com, original author
 *   Samuel Sieb, samuel@sieb.net
 *   Chiaki Koufugata chiaki@mozilla.gr.jp UI i18n
 *   Shawn Wilsher <me@shawnwilsher.com>
 *   Postbox, Inc. <contact@postbox-inc.com>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

/* -*- Mode: C++; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is ChatZilla.
 *
 * The Initial Developer of the Original Code is
 * Netscape Communications Corporation.
 * Portions created by the Initial Developer are Copyright (C) 1998
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *   Robert Ginda, <rginda@netscape.com>, original author
 *   Chiaki Koufugata chiaki@mozilla.gr.jp UI i18n
 *   Samuel Sieb, samuel@sieb.net, MIRC color codes, munger menu, and various
 *   James Ross, silver@warwickcompsoc.co.uk
 *   Postbox, Inc. <contact@postbox-inc.com>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

var CopyPasteHandler = new Object();
 
CopyPasteHandler.allowDrop =
CopyPasteHandler.allowStartDrag =
CopyPasteHandler.onCopyOrDrag =
function ()
{
  return true;
}

CopyPasteHandler.onPasteOrDrop =
function (e, data)
{
  try {
    var file = {};
    var length = {};
    // this will throw when doing plain text editing.  all we have is text/unicode
    data.getTransferData("application/x-moz-file", file, length);

    var ioService = Components.classes["@mozilla.org/network/io-service;1"]
                    .getService(Components.interfaces.nsIIOService);
    var fileHandler = ioService.getProtocolHandler("file")
                    .QueryInterface(Components.interfaces.nsIFileProtocolHandler);    
    var fileSpec = fileHandler.getURLSpecFromFile(file.value);
 
    // if this is a dropbox file, return false 
    // (to indicate the action was handled, do not perform built-in behavior)
    // see bug #8290 for details
    if (IsDropboxFile(file.value))
      return false;
   
    // for html compose, we want drag and drop of image files to do what it currently does (and insert the image inline)
    if (gMsgCompose.composeHTML)
    {
      var filesuffix = fileSpec.substr(fileSpec.lastIndexOf(".")).toLowerCase();

      // XXX todo stop duplicating this image/* logic
      if (filesuffix && (filesuffix == '.jpeg' || filesuffix == '.jpg' || filesuffix == '.png' || filesuffix == '.pjpeg' || filesuffix == '.gif'))
        return true;
    }

    var ignoreDropbox = true;
    if (!DuplicateFileCheck(fileSpec, true))
    {
      var attachment = Components.classes["@mozilla.org/messengercompose/attachment;1"].createInstance(Components.interfaces.nsIMsgAttachment);
      attachment.url = fileSpec;
      attachment.name = "";
      AddAttachment(attachment, ignoreDropbox);
      ChangeAttachmentBucketVisibility(false);
    }
    return false;
  }
  catch (ex)
  {
    // note, we expect this to fail for non-file types
  }
  return true;
}

CopyPasteHandler.QueryInterface =
function (iid)
{
  if (iid.equals(Components.interfaces.nsISupports) ||
      iid.equals(Components.interfaces.nsIClipboardDragDropHooks))
      return this;

  throw Components.results.NS_ERROR_NO_INTERFACE;
}

function SetUpPasteOverride()
{
  var command = "cmd_clipboardDragDropHook";
  var params = {addhook: CopyPasteHandler};
  var dispatcher = document.commandDispatcher;
  var controller = dispatcher.getControllerForCommand(command);
  controller.QueryInterface(Components.interfaces.nsICommandController);

  if (!controller || !controller.isCommandEnabled(command))
    return;

  var cmdparams = Components.classes["@mozilla.org/embedcomp/command-params;1"].createInstance(Components.interfaces.nsICommandParams);

  for (var i in params)
    cmdparams.setISupportsValue(i, params[i]);

  controller.doCommandWithParams(command, cmdparams);
}
